local wesnoth = wesnoth
local laterlife = laterlife
local ipairs = ipairs
local string = string
local T = wesnoth.require("lua/helper.lua").set_wml_tag_metatable {} 

local width, height, border = wesnoth.get_map_size()

width = (width - 1) * 0.5

local mutation_probability = 0.10

local function select_random_array_index(array)
    return array[wesnoth.random(#array)]
end

local mutation_table = {        
}

local function get_mirror (x) 
    return width + 2 - (x - width) 
end
    
local function apply_mutation (table_row)
    local x = table_row[1][1]
    local x2 = get_mirror(x)
    local y = table_row[1][2]
    local types_array = table_row[2]
    local selected = select_random_array_index(types_array)
    wesnoth.set_terrain(x,y, selected)
    wesnoth.set_terrain(x2,y,selected)
end

for_each_index(mutation_table, function (index, element) 
    if wesnoth.random() < mutation_probability then
        apply_mutation(element)
    end
end)
